#!/usr/bin/perl

# Copyright (c) 1997 SOFTCON GmbH
#
# Permission to use, copy, modify, distribute, and sell this software and
# its documentation for any purpose is hereby granted without fee, provided
# that (i) the above copyright notices and this permission notice appear in
# all copies of the software and related documentation, and (ii) the names of
# Jens Lippenberger and SOFTCON may not be used in any advertising or
# publicity relating to the software without the specific, prior written
# permission of Jens Lippenberger and SOFTCON.
#
# THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
# EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY
# WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
#
# IN NO EVENT SHALL JENS LIPPENBERGER OR SOFTCON BE LIABLE FOR
# ANY SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND,
# OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
# WHETHER OR NOT ADVISED OF THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF
# LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE
# OF THIS SOFTWARE.


$db_path="@@FAQ@@";

sub ScanMosaicFormular
 {
  my ($input, $method, $pair, @pairs, $key, $value, %values);

  $method = $ENV{'REQUEST_METHOD'};
  if ($method =~ /^(GET|HEAD)$/)
   {
    $input = $ENV{'QUERY_STRING'};
   }
  elsif ($method eq 'POST')
   {
    read (STDIN, $input, $ENV{'CONTENT_LENGTH'});
   }

  @pairs = split(/&/, $input);
  foreach $pair (@pairs)
   {
    ($key, $value) = ($pair =~ /(\w+)=(\S+)/);
    $value =~ tr/+/ /;
    $value =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/eg;
    $values{$key} = $value;
   }

  return %values;
 }

sub suche
 {
  my ($word) = @_;
  my ($line);

  $word =~ tr/A-Z/a-z/;

  open( F, "$db_path/index.dat");
  while( <F> )
   {
    if (/$word/)
     {
      $line = $_;
      while( $line =~ /([0-9]+)/ )
       {
        $treffer{$1} = 1;
        $line = $';
       }
     }
   }
  close( F );
 }

sub ausgabe
 {
  my ($help, $key);

  open( F, "$db_path/files.dat");
  while (<F>)
   {
    if( /(\S+) (.+)/ )
     {
      push @files, $1;
      push @comments, $2;
     }
   } 
  close( F );

  print "Content-type: text/html\n";
  print "\n";
  print "<HTML>\n";
  print "<HEAD>\n";
  print "<TITLE>HylaFAQ Search</TITLE>\n";
  print "</HEAD>\n";
  print "<H1>HylaFAQ Search</H1>\n";
  print "<BODY>\n";
  print "<OL>\n";
  foreach $key ( keys %treffer )
   {
    $help = $files[$key];
    print "<LI><A HREF=\"/HylaFAQ/", $help, "\">";
    print substr( $help, 0, length($help) - 5 );
    print "</A> ";
    print $comments[$key], "\n";
   }
  print "</OL>\n";
  print "</BODY>\n";
  print "</HTML>\n";
 }

sub my_main
 {
  my (%values) = &ScanMosaicFormular;

  &suche( $values{'SEARCH'} );
  &ausgabe;
 }

&my_main;

